#
# -- Miniml OpenCV video capture --
# 
# minimal example, ChS 9.8.2019-2024


import cv2
import numpy as np

global gVCap  # holds the capture session, shared amoung python functions below

#--------------------------------------------------------------------------------
# init the camera session

def _OCV_camInit_P(camera = 0,width = 640, height = 480, fps=50):
    global gVCap
    gVCap = cv2.VideoCapture(camera)
    if (gVCap.isOpened() == False): 
                logging.error("Unable to open camera feed")
                return -666
    gVCap.set(cv2.CAP_PROP_FRAME_WIDTH,width)
    gVCap.set(cv2.CAP_PROP_FRAME_HEIGHT,height)
    gVCap.set(cv2.CAP_PROP_FPS, fps)
  
    w2 = gVCap.get(cv2.CAP_PROP_FRAME_WIDTH)
    if (w2 != width) :
                return -1
    return 0

#--------------------------------------------------------------------------------
# grab the current frame and copy it to the shared memory

def _OCV_camSnap_P():
    global gVCap
    global idx

    ret,frame = gVCap.read()
    return frame.flatten()

#--------------------------------------------------------------------------------
# close the camera session

def _OCV_camClose_P():
    global gVCap
    gVCap.release()
    return 0


